#ifndef MERGE_SEARCH_INCLUDED
#define MERGE_SEARCH_INCLUDED

#include "bool.h"
#include "list.h"
#include "genomicpos.h"
#include "univcoord.h"

#include "stage1hr.h"
#include "knownsplicing.h"
#include "compress.h"

#include "univdiagpool.h"
#include "intlistpool.h"
#include "listpool.h"
#include "pathpool.h"
#include "vectorpool.h"
#include "method.h"

extern void
Merge_search (int *found_score,

	      List_T *unextended_sense_paths_gplus, List_T *unextended_sense_paths_gminus,
	      List_T *unextended_antisense_paths_gplus, List_T *unextended_antisense_paths_gminus,
		    
	      List_T *sense_paths_gplus, List_T *sense_paths_gminus,
	      List_T *antisense_paths_gplus, List_T *antisense_paths_gminus,

	      Stage1_T stage1, Knownsplicing_T knownsplicing, int querylength,
	      Compress_T query_compress_fwd, Compress_T query_compress_rev,
	      int max_insertionlen, int max_deletionlen, Chrpos_T overall_end_distance,
	      Univdiagpool_T univdiagpool, Intlistpool_T intlistpool,
	      Univcoordlistpool_T univcoordlistpool, Listpool_T listpool,
	      Pathpool_T pathpool, Vectorpool_T vectorpool, Hitlistpool_T hitlistpool,
	      Method_T method);

extern void
Merge_search_setup (int index1part_in, EF64_T chromosome_ef64_in);

#endif
